% GBM6103A, Cours  Traitement d'images mdicales I 
% Dmonstration de l'effet du sous chantillonnage d'une image
%
%
%    Copyright (C) 2008-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.
%

% close all, clear

set(0, 'DefaultFigureWindowStyle', 'Normal')

A = imread('Barbara.tif');
A = double(A) / 256;

figure(1), clf
imshow(A)
title('Image originale', 'FontSize', 14)


[M, N] = size(A);
M1 = 4*ceil(M/4);
N1 = 4*ceil(N/4);

AA = fft2(A, M1, N1);

AA((M1/4+1):3*M1/4, (N1/4+1):3*N1/4) = zeros(M1/2, N1/2);
CC = AA([1:(M1/4), (3*M1/4+1):M1], [1:(N1/4), (3*N1/4+1):N1]);

B = real(ifft2(AA));
B = B(1:M, 1:N);

C = real(ifft2(CC));
C = C(1:M/2, 1:N/2)/4;

C1 = A(1:2:M, 1:2:N);


figure(2), clf
imshow(C1)
title('Image sous-chantillonne par dcimation', 'FontSize', 14)


figure(3), clf
imshow(C)
title('Image sous-chantillonne dans le domaine frquentiel', 'FontSize', 14)

figure(4), clf
imagesc(C-C1), axis equal, colormap gray, colorbar
set(gca, 'Xlim', [1 N/2], 'Ylim', [1 M/2])
title('Diffrence entre les deux images', 'FontSize', 14)

disp('Taper <RC> pour poursuivre')
pause

B1 = mae_bil(C1, 2);

figure(2), clf
imshow(B1)
title('Image sous-chantillonne par dcimation et r-interpole', 'FontSize', 14)

figure(3), clf
imshow(B)
title('Image sous-chantillonne dans le domaine frquentiel et r-interpole', 'FontSize', 14)

figure(4), clf
imagesc(A-B1), axis equal, colormap gray, colorbar
set(gca, 'Xlim', [1 N], 'Ylim', [1 M])
title('Erreur, image sous-chantillonne par dcimation et r-interpole', 'FontSize', 14)

