% demo_debruitage
% Cours  Traitement d'images mdicales I , demo 2 : exemples de
% dbruitage d'une image rlle
%    Copyright (C) 2008-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

close all, clear

A = imread('Thorax2.tif');
classin = class(A);

figure(1)
% set(gcf, 'Windowstyle', 'Docked')


clf, imshow(A), impixelinfo
title('Image brute', 'FontSize', 16)

disp('Taper <RC> pour poursuivre')
pause

% Dbruitage par moyennage

N = 5;
h = fspecial('average', N);
B = imfilter(A, h, 'same');

figure(2)
% set(gcf, 'Windowstyle', 'Docked')


clf, imshow(B), impixelinfo
title('Image moyenne', 'FontSize', 16)

disp('Taper <RC> pour poursuivre')
pause

% Dbruitage L2L1

[M, N] = size(A);

im = double(A);

h = ones(1,1);

lambda1 = 1
lambda2 = 30

im0 = zeros(M*N, 1);
%im0 = im(:);
delta = max(im(:)) /100;


par = struct('im', im, 'h', h, 'lambda1', lambda1, ...
    'lambda2', lambda2, 'delta', delta);
opts = zeros(1, 9);
% opts = [1 2 1 1e-07 1e-06 100 1e-01  1e-02  10];
[imr, info, perf] = conj_grad('cg_l2l1', par, im0, opts);

eval(['C = ', classin, '(reshape(imr(:, end), M, N));'])

figure(3)
% set(gcf, 'Windowstyle', 'Docked')

clf, imshow(C), impixelinfo
title('Image dbruite, approche L_2L_1', 'FontSize', 16)
