% demo_seg
% Cours  Traitement d'images mdicales I , demo 4 : exemple de
% segmentation d'une image rlle
%    Copyright (C) 2008-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

close all, clear
set(0,'DefaultFigureWindowStyle','docked') % Figures  docked  par dfaut 

fac = 1.5; % facteur pour la superposition des contours

im = imread('cerveau.tif');
% im = imread('Thorax2.tif');
classin = class(im);

figure(1), clf, imshow(im), impixelinfo
title('Image brute', 'FontSize', 16)

disp('Taper <RC> pour poursuivre')
pause

sigma = 2
[BW, th] = edge(im, 'log', 0, sigma);
iml = min(double(im)/(256*fac-1) + BW, 1);
figure(2), clf, imshow(iml), impixelinfo
title(['Dtection de contours, LoG + seuillage, \sigma', ...
      sprintf(' = %1.0f', sigma)], 'FontSize', 16)

disp('Taper <RC> pour poursuivre')
pause

% Effet de sigma

sigma = 4
[BW, th] = edge(im, 'log', 0, sigma);
iml = min(double(im)/(256*fac-1) + BW, 1);
figure(3), clf, imshow(iml), impixelinfo
title(['Dtection de contours, LoG + seuillage, \sigma', ...
      sprintf(' = %1.0f', sigma)], 'FontSize', 16)

disp('Taper <RC> pour poursuivre')
pause

% Effet du seuillage

[BW, th] = edge(im, 'log', [], sigma);
iml = min(double(im)/(256*fac-1) + BW, 1);
figure(4), clf, imshow(iml), impixelinfo
title('Effet du seuillage', 'FontSize', 16)

disp('Taper <RC> pour poursuivre')
pause

% Segmentation par champs de Markov
penal = 1; % Pnalisation de la vraisemblance pour l'estimation des
           % paramtres du modle 

N = 4
y = double(im);
emtel

figure(5), clf, plot(GLxvect); title('GLxvect');
figure(6), clf, plot(NLLvect); title('NLLvect');

niter = size(mvect, 2)-1;
figure(7)
subplot(2,2,1), plot(0:niter, mvect), set(gca, 'Ylim', [0 255]), title('Moyenne \it{m}')
subplot(2,2,2), plot(0:niter, sigma2vect), title('Variance \sigma^2')
subplot(2,2,3), plot(0:niter, lambdavect), title('Paramtre \lambda')
subplot(2,2,4), plot(0:niter, muvect), title('Paramtre \mu')

eval(['ims = ', classin, '(MAPimage);'])
figure(8), clf, imshow(ims), impixelinfo

title('Image segmente par EM tlgraphique', 'FontSize', 16)

